<template>
  <div
    class="sticky top-0 z-40 flex items-center justify-between px-4 py-5 text-sm bg-white border-b max-h-header-75 md:px-6 lg:px-12 border-grey-20"
  >
    <nav class="hidden lg:flex" aria-label="Header">
      <ul role="menu" class="flex justify-between">
        <li
          role="none"
          name="productMenu"
          class="pr-12 relative main-menu py-8"
          @click="showHeaderMenu('productMenu')"
        >
          <NuxtLink
            name="productMenu"
            :to="menuName === 'productMenu' ? '/' : ''"
            class="menu-hov text-grey-60"
            :class="[menuName === 'productMenu' ? 'menu-click text-black' : '']"
            role="menuitem"
            @click.native="tealiumClickHeader('Products')"
          >
            Products
          </NuxtLink>
          <MKHeaderMenu
            v-show="menuName === 'productMenu'"
            title-name="product"
            name="productMenu"
          />
        </li>
        <li
          role="none"
          name="technologyMenu"
          class="pr-12 relative main-menu py-8 group"
          @click="showHeaderMenu('technologyMenu')"
        >
          <NuxtLink
            name="technologyMenu"
            to="/technology/"
            class="menu-hov text-grey-60"
            :class="[
              menuName === 'technologyMenu' ? 'menu-click text-black' : '',
            ]"
            role="menuitem"
            @click.native="tealiumClickHeader('Technology', '/technology')"
          >
            Technology
          </NuxtLink>
          <MKHeaderMenu
            v-show="menuName === 'technologyMenu'"
            title-name="technology"
            name="technologyMenu"
          />
        </li>
        <li
          role="none"
          name="supportMenu"
          class="relative main-menu py-8 group"
          @click="
            showHeaderMenu('supportMenu')
            tealiumContactSupport()
          "
        >
          <a
            name="supportMenu"
            href="https://help.molekule.com/hc/en-us"
            class="menu-hov text-grey-60"
            :class="[menuName === 'supportMenu' ? 'menu-click text-black' : '']"
            role="menuitem"
            target="_blank"
            rel="noopener"
            >Support</a
          >
          <!-- <MKHeaderMenu titleName='support' name='supportMenu' v-show="menuName === 'supportMenu'"/> -->
        </li>
      </ul>
    </nav>

    <span
      :class="[showHamNav ? 'icon-close' : 'icon-hamburger', 'lg:hidden']"
      @click="showHamNav = !showHamNav"
      @keydown.enter="showHamNav = !showHamNav"
    ></span>
    <nav
      v-show="showHamNav"
      class="absolute left-0 w-full mt-0 bg-white lg:hidden md:fixed top-18 md:h-full"
    >
      <div
        v-show="!AUTHENTICATED && !userDisplayName"
        class="pb-4 mx-4 mt-4 border-b border-grey-20 md:hidden"
      >
        <MkButton
          button-title="Shop"
          btn-type="btn-standard"
          btn-class="font-primary-font-light w-24 h-9"
        />
      </div>

      <ul
        class="flex flex-col justify-between px-4 py-6 leading-10 md:px-10 md:pt-10 md:pb-12 text-28 font-secondary-font-regular"
      >
        <li
          role="none"
          name="productMenu"
          class="pr-12 relative main-menu py-8"
          @click="showHeaderMenu('productMenu')"
        >
          <NuxtLink
            name="productMenu"
            :to="menuName === 'productMenu' ? '/' : ''"
            class="menu-hov text-grey-60"
            :class="[menuName === 'productMenu' ? 'menu-click text-black' : '']"
            role="menuitem"
            @click.native="tealiumClickHeader('Products')"
          >
            Products
          </NuxtLink>
          <MKHeaderMenu
            v-show="menuName === 'productMenu'"
            title-name="product"
            name="productMenu"
          />
        </li>
        <li class>
          <NuxtLink name="technology" to="technology/">Technology</NuxtLink>
        </li>
        <li class>
          <a
            class="mk-link"
            href="https://help.molekule.com/hc/en-us"
            target="_blank"
            rel="noopener"
            >Support</a
          >
        </li>
      </ul>
      <!-- <ul
        v-show="userDisplayName"
        class="flex flex-col px-4 pt-6 text-lg md:hidden"
      > -->
      <!-- <li v-for="item in navMenu" class="pb-6" :key="item.text">
          <NuxtLink :to="item.page" >{{ item.text }}</NuxtLink>
        </li> 
        <li class="border-b border-grey-20"></li>-->
      <!-- <li class="py-6">
          <button @click="logout">Signout</button>
        </li>
      </ul> -->
      <ul class="flex flex-col px-4 pt-6 text-lg md:hidden">
        <NuxtLink
          name="login"
          :to="AUTHENTICATED ? '/D2C/account/dashboard/' : '/D2C/login/'"
          @click.native="tealiumClickHeader('Account', '/login')"
          @click="$emit('switch_form', 'LoginForm')"
          >Account</NuxtLink
        >
      </ul>
    </nav>
    <NuxtLink
      to="/D2C/"
      aria-label="Molekule Logo"
      class="absolute left-0 right-0 w-32 mx-auto"
      @click.native="tealiumClickHeader('Molekule Logo')"
    >
      <img src="~/assets/images/MKLogoBlack.jpg" alt="Molekule Logo" />
    </NuxtLink>
    <div class="relative flex items-center">
      <div class="hidden pr-7 md:flex md:items-center">
        <NuxtLink
          id="accMgmt_account_btn"
          :to="AUTHENTICATED ? '/D2C/account/dashboard/' : '/D2C/login/'"
          class="pr-6"
          @click.native="tealiumClickHeader('Account')"
          @click="$emit('switch_form', 'LoginForm')"
          >Account</NuxtLink
        >
        <MkButton
          id="accMgmt_register_btn"
          button-title="Shop"
          btn-type="btn-standard"
          btn-class="font-primary-font-light"
          mksecondary-class="py-2 leading-5 text-sm"
        />
      </div>
      <!-- <div class="group">
        <span
          v-show="userDisplayName"
          @click.prevent="showNav = !showNav"
          class="hidden py-8 pr-4 cursor-pointer md:block"
          tabindex="0"
          >{{ `Hi, ${userDisplayName}` }}</span
        >
        <div
          v-show="userDisplayName"
          class="fixed right-0 hidden pt-6 bg-white border-b border-l border-r lg:group-hover:block top-18 border-grey-20"
        >
          <ul class="w-48"> -->
      <!-- <li v-for="item in navMenu" class="px-6 pb-4" :key="item.text">
              <NuxtLink :name="item.text" :to="item.page">{{ item.text }}</NuxtLink>
            </li> 
            <li class="border-b border-grey-20"></li>-->
      <!-- <li class="px-6 py-4">
              <button @click="logout" v-if="!logoutInProgress">Signout</button>
              <MKSpinnerAnimation v-if="logoutInProgress"/>
            </li>
          </ul>
        </div>
      </div> -->

      <button
        title="cart bag"
        class="relative flex items-center justify-center focus:ring-black focus:ring-1"
        @click="TOGGLE_SIDE_CART"
      >
        <div
          class="absolute cart_indicator"
          :class="[!LINE_ITEMS.length ? 'hidden' : 'block']"
        ></div>
        <svg
          xmlns="http://www.w3.org/2000/svg"
          width="24"
          height="24"
          viewBox="0 0 24 24"
        >
          <g fill="none" fill-rule="evenodd">
            <g fill="#535354">
              <g>
                <g>
                  <g>
                    <path
                      d="M9 .25c2.534 0 4.627 1.84 4.745 4.185l.005.208v.607h4.07l-1.004 11.303c-.188 2.366-2.11 4.197-4.428 4.197H5.613c-2.318 0-4.24-1.83-4.427-4.19L.18 5.25h4.07v-.607C4.25 2.2 6.392.25 9 .25zm7.18 6.5h-2.43V9.5h-1.5V6.75h-6.5V9.5h-1.5V6.75H1.82l.86 9.684c.123 1.535 1.31 2.722 2.758 2.81l.175.006h6.775c1.526 0 2.806-1.22 2.933-2.823l.859-9.677zM9 1.75c-1.745 0-3.147 1.22-3.245 2.725l-.005.168v.607h6.5v-.607C12.25 3.06 10.81 1.75 9 1.75z"
                      transform="translate(-48 -510) translate(48 222) translate(0 288) translate(3 1)"
                    />
                  </g>
                </g>
              </g>
            </g>
          </g>
        </svg>
      </button>
    </div>
    <div
      v-show="showNav && userDisplayName"
      class="fixed right-0 hidden pt-6 bg-white border-b border-l border-r md:flex top-18 border-grey-20"
    >
      <ul class="w-48">
        <li v-for="item in navMenu" :key="item.text" class="px-6 pb-4">
          <NuxtLink :name="item.text" :to="item.page">{{ item.text }}</NuxtLink>
        </li>
        <!-- <li class="border-b border-grey-20"></li>
        <li class="px-6 py-4">
          <button @click="logout">Signout</button>
        </li> -->
      </ul>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import MKHeaderMenu from '~/components/D2C/organisms/MkHeader/MkHeaderMenu.vue'
import MkButton from '~/components/D2C/atoms/MkSecondaryButton.vue'
export default {
  name: 'MkGLobalHeader',
  components: { MkButton, MKHeaderMenu },
  data() {
    return {
      showNav: false,
      signed_in: false,
      showHamNav: false,
      logoutInProgress: false,
      navMenu: [
        { text: 'Dashboard', page: '/account/dashboard/' },
        { text: 'Orders', page: '/account/orders/' },
        { text: 'Filter auto-refills', page: '/account/filters/' },
        // {text: 'Quotes', page: '/account/quotes'},
        { text: 'Payments', page: '/account/payments/' },
        { text: 'Shipping', page: '/account/shipping/' },
        { text: 'Your profile', page: '/account/yourProfile/' },
        { text: 'Company profile', page: '/account/companyProfile/' },
        // {text: 'Tax exemptions', page: '/account/taxExemptions'},
      ],
      menuName: '',
    }
  },
  computed: {
    ...mapState('CART_STORE', ['LINE_ITEMS', 'CART_ID', 'HAS_QUOTE']),
    ...mapState('USER_STORE', ['CUSTOMER_PROFILE', 'AUTHENTICATED']),
    userDisplayName() {
      return (this.CUSTOMER_PROFILE && this.CUSTOMER_PROFILE.firstName) || ''
    },
  },
  watch: {
    CART_ID() {
      this.updateCartStatus(this.CART_ID)
    },
  },
  async mounted() {
    document.addEventListener('click', this.handleClickOutside)
    document.addEventListener('mousemove', this.handleMouseMoveOutside)
    await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER')
    await this.$store.dispatch('CART_STORE/FETCH_CART', {})
    // this.updateCartStatus(this.CART_ID);
  },
  methods: {
    async logout() {
      this.logoutInProgress = true
      await this.$store.dispatch('USER_STORE/LOGOUT')
      this.tealiumClickHeader('Signout')
      this.logoutInProgress = false
    },
    toggleNav() {
      this.showNav = !this.showNav
    },
    TOGGLE_SIDE_CART() {
      this.$store.dispatch('MK_CART_STORE/TOGGLE_SIDE_CART', 'MK_SIDE_CART')
    },
    handleMouseMoveOutside(evt) {
      if (
        !evt.target.attributes.name ||
        evt.target.attributes.name.value !== this.menuName
      ) {
        this.menuName = ''
      }
    },
    mouseEnter() {
      this.showNav = !this.showNav
    },
    mouseLeave() {
      // this.showNav = false;
    },
    showHeaderMenu(elName) {
      if (this.menuName !== elName) {
        this.menuName = elName
      } else if (this.menuName === elName) {
        this.menuName = ''
      }
    },
    quickRegister() {
      this.$store.commit('QUICK_REGISTER_STORE/TOGGLE_QUICK_REGISTER')
      this.tealiumClickRegister()
    },
    tealiumClickRegister() {
      const tealiumPayload = {
        event_category: 'B2B Quick Register',
        event_action: 'Clicked Quick Register Button',
        event_label: 'Register',
        event_value: 'quick_register_start',
        page_type: 'homepage',
      }
      this.$root.$telium.setTealiumPayload(
        'quick_register_start',
        tealiumPayload
      )
    },
    tealiumContactSupport() {
      const tealiumPayload = this.$store.state.USER_STORE
        .CUSTOMER_DETAILS_TEALIUM
      tealiumPayload.event_category = 'Help'
      tealiumPayload.event_action = 'Submitted Support Form'
      tealiumPayload.event_label = 'Support'
      tealiumPayload.event_value = 'contact_support'
      tealiumPayload.customer_type = 'Mo-registered'
      tealiumPayload.customer_tos_opt_in = ''
      tealiumPayload.customer_refill_opt_in = false
      tealiumPayload.customer_marketing_opt_in = false
      tealiumPayload.customer_industry_category = ''
      tealiumPayload.customer_email_preference = this.$store.state.USER_STORE.CUSTOMER_DETAILS_TEALIUM.customer_email
      this.$root.$telium.setTealiumPayload('contact_support', tealiumPayload)
    },
    tealiumClickHeader(item, toUrl) {
      if (item === 'Account') {
        this.showHamNav = false
      }
      const tealiumPayload = this.$store.state.USER_STORE
        .CUSTOMER_DETAILS_TEALIUM
      tealiumPayload.event_category = 'Header'
      tealiumPayload.event_action = 'Clicked Navigation Bar'
      tealiumPayload.event_label = item
      tealiumPayload.page_type = item
      tealiumPayload.click_text = item
      tealiumPayload.click_url = `${window.location.href}${toUrl}`
      tealiumPayload.event_value = item
      tealiumPayload.click_location = 'Header'
      this.$root.$telium.setTealiumPayload('clicked_header', tealiumPayload)
    },
    async updateCartStatus(cartId) {
      if (cartId) {
        await this.$store.dispatch('CART_STORE/FETCH_CART', {
          cartID: this.CART_ID,
        })
        // await this.$store.dispatch('CART_STORE/CHECK_CART_HAS_QUOTE');
      }
    },
  },
}
</script>

<style lang="scss">
.menu-hov,
.sub-menu-hov {
  position: relative;
  &::after {
    position: absolute;
    bottom: -6px;
    left: 0;
    width: 100%;
    height: 1px;
    content: '';
    background-color: transparent;
    transition: all 0.4s ease;
  }
  &:hover {
    @apply text-black;
    &::after {
      background-color: #000;
    }
  }
}
.menu-click {
  position: relative;
  color: #000;
  &::after {
    position: absolute;
    bottom: -6px;
    left: 0;
    width: 100%;
    height: 1px;
    content: '';
    background-color: #000;
  }
}
</style>
